import javax.realtime.*; 

/**
 * Demonstrate using an AEH as a fault notification mechanism.
 */
public class FaultEvt extends RealtimeThread
{
  static int maxPriority; 
  
  public FaultEvt(SchedulingParameters sched)
  {
    super(sched); 
  }
  
  public void run()
  {
    AsyncEventHandler handler = new AsyncEventHandler() {
      public void handleAsyncEvent(){
        System.err.println("Run method: notified"); 
      }
    };
    AsyncEvent event = new AsyncEvent(); 
    RealtimeThread thisThread =
    RealtimeThread.currentRealtimeThread(); 
    
    handler.setSchedulingParameters((SchedulingParameters)
    (new PriorityParameters(maxPriority-3))); 
    
    event.addHandler(handler); 
    process1(event); 
    event.removeHandler(handler); 
  }
  
  private void process1(AsyncEvent notify)
  {
    AsyncEventHandler p2Handler = new AsyncEventHandler() {
      public void handleAsyncEvent(){
        System.err.println("process1 method: notified"); 
      }
    };
    p2Handler.setSchedulingParameters((SchedulingParameters)
    (new PriorityParameters(maxPriority-4))); 
    notify.addHandler(p2Handler); 
    process2(notify); 
    notify.removeHandler(p2Handler); 
  }
  
  private void process2(AsyncEvent notify)
  {
    //... something bad happened
    // fire the notification async event.
    {
      notify.fire(); 
      return; 
    }
  }
  
  public static void main(String [] args)
  {
    maxPriority = PriorityScheduler.instance().getMaxPriority(); 
    SchedulingParameters sched =
    (SchedulingParameters)(new PriorityParameters(maxPriority-5)); 
    FaultEvt me = new FaultEvt(sched); 
    me.start(); 
    try{
      me.join(); 
    }catch(Exception e){}; 
    System.exit(0); 
  }

}

