import javax.realtime.*;
/** Demonstrate binding a Posix signal to an async event handler
 */

public class SigEvt extends RealtimeThread {
  public void run(){
    MemoryArea immortal = ImmortalMemory.instance();
    AsyncEventHandler handler = null;
    AsyncEvent event = null;
    try{
      handler = (AsyncEventHandler)
        immortal.newInstance(SigHandler.class);
      event = (AsyncEvent)
        immortal.newInstance(AsyncEvent.class);
    } catch (InstantiationException e){
      e.printStackTrace();
    } catch (IllegalAccessException e){
      e.printStackTrace();
    }

    event.addHandler(handler);
    event.bindTo("25");	// Signal number 25

    //  Pretend to signal
    event.fire();event.fire();event.fire();
    try {
      Thread.sleep(1000); //	Let the AEH run 
    } catch(Exception e){}
    event.removeHandler(handler);
  }

  public static void main(String [] args){
    SigEvt rt = new SigEvt();
    rt.start();
    try {
      rt.join();
    } catch (InterruptedException e){}
    System.exit(0);
  }
}
