import javax.realtime.*; 
/**
 * Demonstrate use of an AEH driven by a one-shot timer.
 * It will print "Running" once per second until the one-shot timer
 * goes off in ten seconds.
 */
public class OSTimer
{
  static boolean stopLooping = false; 
  public static void main(String [] args)
  {
    AsyncEventHandler handler = new AsyncEventHandler() {
      public void handleAsyncEvent(){
        stopLooping = true; 
      }
    };
    OneShotTimer timer = new OneShotTimer(
    new RelativeTime(10000, 0), // Fire in 10 seconds
    handler); 
    
    timer.start(); 
    while(!stopLooping){
      System.out.println("Running"); 
      try{
        Thread.sleep(1000); 
      }catch(Exception e){}
    }
    System.exit(0); 
  }
}
