import javax.realtime.*; 
/**
 * Demonstrate use of an AEH attached to a periodic timer.
 * (For 20 seconds it will print "tick" every second and a half.)
 */
public class PTimer
{
  public static void main(String [] args)
  {
    AsyncEventHandler handler = new AsyncEventHandler() {
      public void handleAsyncEvent(){
        System.out.println("tick"); 
      }
    };
    PeriodicTimer timer = new PeriodicTimer(
    null, // Start now
    new RelativeTime(1500, 0), // Tick every 1.5 seconds
    handler); 
    
    timer.start(); 
    try{
      Thread.sleep(20000); // Run for 20 seconds
    }catch(Exception e){}
    timer.removeHandler(handler); 
    System.exit(0); 
  }
}
