import javax.realtime.*; 
/**  Another demonstration of Timed.
 */

public class TimedTest extends RealtimeThread
{
  public void run()
  {
    Timed tm = new Timed(new RelativeTime(1000, 0)); 
    tm.doInterruptible(new Interruptible(){
      private volatile int n; 

      public void interruptAction(AsynchronouslyInterruptedException e){
        System.out.println("Interrupted at " + n); 
      }
      
      public void run(AsynchronouslyInterruptedException e)
          throws AsynchronouslyInterruptedException{
        System.out.println("Entering Timed run"); 
        while(n<100000000) n += 1; 
        
        System.out.println(
        "Wow! The timed method ran for a long time."); 
      }
    }); 
  }
  
  public static void main(String [] args)
  {
    TimedTest rt = new TimedTest(); 
    rt.start(); 
    try{
      rt.join(); 
    }catch(InterruptedException e){
      System.out.println("Interrupted in join"); 
    }
  }
}
