/** A quick example of ways to create memory in immortal:
 *  newInstance(), enter, and create a thread using immortal as
 *  its memory area.
 */
import javax.realtime.*;
public class QuickImmortal extends RealtimeThread {
  Object alsoImmortal;

  public void run(){
    //  Create an immortal object using the simple
    //  form of newInstance
    try{
      Object inImmortal = ImmortalMemory.instance().
        newInstance(Object.class);
    } catch (IllegalAccessException access){
      System.out.println(access);
    } catch (InstantiationException instant){
      System.out.println(instant);
    }
    //  Enter immortal, and use it to create an immortal
    //  object 
    ImmortalMemory.instance().enter(new Runnable() {
      public void run(){
        QuickImmortal.this.alsoImmortal = new Object();
      }
    });

    //  Create a new thread that will start with its
    //  memory allocation context == Immortal
    RealtimeThread nRtT = new RealtimeThread(null, null, null,
      ImmortalMemory.instance(),
      null, 
      new NestedThread());
    nRtT.start();
    try{nRtT.join();} catch(Exception e){}
  }

  class NestedThread implements Runnable {
    public void run(){
      System.out.println("Running in immortal");
    }
  }


  public static void main(String [] args){
    QuickImmortal rt = new QuickImmortal();
    rt.start();
    try {rt.join();} catch (Exception e){}
  }
}
