import javax.realtime.*; 
/** Start a no-heap real-time thread that just 
 *  prints a message and terminates.
 */
public class InImmortal extends RealtimeThread
{
  /**
   * A little Noheap thread
   */
  public static class NhRTT extends NoHeapRealtimeThread
  {
    /**
     * Constructor for NhRTT
     */
    public NhRTT(SchedulingParameters sched, MemoryArea mem)
    {
      super(sched, mem); 
    }
    public void run()
    {
      System.out.println("In NOHEAP!"); 
    }
  }
  
  /**
   * Run method for a RealtimeThread
   */
  public void run()
  {
    ImmortalMemory.instance().enter(new Runnable() {
      public void run(){
        NhRTT nhrtt = new NhRTT(null, ImmortalMemory.instance()); 
        nhrtt.start(); 
        try{
          nhrtt.join(); 
          System.out.println("NHRtT ended");
        }catch(InterruptedException e){}
      }
    }
    ); 
  }
  
  public static void main(String [] args)
  {
    InImmortal rtt = new InImmortal(); 
    rtt.start(); 
    try{
      rtt.join(); 
      System.out.println("RT Thread ended");
    }catch(InterruptedException e){}
  }
}
