import javax.realtime.*; 

/** Start a no-heap thread running in a scoped memory. */

public class InScope extends RealtimeThread
{
  /**
   * A little Noheap thread
   */
  public class NhRTT extends NoHeapRealtimeThread
  {
    /**
     * Constructor for NhRTT
     */
    public NhRTT(){
      super(null, 
          RealtimeThread.currentRealtimeThread().getCurrentMemoryArea()); 
    }

    public void run(){
      System.out.println("In NOHEAP!");
    }
  }
 
  public class StartNhRTT implements Runnable {
    public void run(){
        NhRTT nhrtt = null;
        try {      
            nhrtt = new NhRTT(); 
        }  catch (IllegalArgumentException e){
            System.out.println("Exception thrown from new NhRTT()");
            e.printStackTrace();
            try {
                throw (RuntimeException)ImmortalMemory.instance().newInstance(RuntimeException.class);
            } catch(Throwable e2){
            }
        }

      nhrtt.start(); 
      try{
        nhrtt.join(); 
        System.out.println("nhrtt done.");
      }
      catch(InterruptedException e){}
      catch(Throwable t){
        System.out.println("Exception thrown by nhrtt.join");
        System.out.println(t);
      }
    }
  } 
  
  /**
   * Run method for a RealtimeThread
   */
  public void run()
  {
    //  We need the NHRTT's scope stack rooted at immortal.
    ImmortalMemory.instance().enter(new Runnable(){
             public void run() {
                 // Create the memory area the noheap thread
                 // will use
                 VTMemory mem1 = new VTMemory(3*1024, 3*1024); 
                 StartNhRTT starter = new StartNhRTT();
                 mem1.enter(starter);
            }
            });

  }
  
  public static void main(String [] args)
  {
    InScope rtt = new InScope(); 
    rtt.start(); 
    try{
      rtt.join(); 
      System.out.println("RTT completed");
    }catch(InterruptedException e){}
  }
}
