/**  Deomonstrate the process of changing the priority inversion
 *   avoidance algorithm for one object.
 *   This will only work if the system actually supports 
 *   priority ceiling emulation protocol.  (It is an optional
 *   feature of the RTSJ.)
 */

import javax.realtime.*; 

public class ToPcep2
{
  public synchronized int foo()
  {
    return 1; 
  }
  
  public static void main(String [] args)
  {
    ToPcep2 obj = new ToPcep2(); 
    PriorityCeilingEmulation pce = new PriorityCeilingEmulation(
        PriorityScheduler.instance().getNormPriority() + 10); 
    // Set PCEP for just one object
    MonitorControl.setMonitorControl(obj, pce); 
    System.out.println(obj.foo()); 
  }
}
