/** A Runnable that demonstrates a real-time thread getting and
 *  increasing its priority.
 */
import javax.realtime.*; 
public class RunMe implements Runnable
{
  public void run()
  {
    RealtimeThread me = RealtimeThread.currentRealtimeThread(); 
    int initialPriority; 
    PriorityParameters pp; 
    
    pp = (PriorityParameters)me.getSchedulingParameters(); 
    initialPriority = pp.getPriority(); 
    System.out.println("Initial priority=" + initialPriority); 
    pp.setPriority(initialPriority+1); 
    System.out.println("New priority=" + pp.getPriority()); 
    pp = new PriorityParameters(initialPriority + 2); 
    me.setSchedulingParameters((SchedulingParameters)pp); 
    System.out.println("New priority=" + pp.getPriority()); 
  }
}
