import javax.realtime.*; 
/**  Demonstrate changing the scheduler to a least-laxity scheduler.
 *   (This is not even an optional part of the RTSJ, so it is not
 *   likely to actually happen.)
 */
public class ChangeSched
{
  static public void main(String [] args)
  {
    Scheduler scheduler = FindScheduler.findScheduler("LLaxity"); 
    if(scheduler==null){
      System.out.println("No least laxity scheduler was found"); 
    }else{
      RealtimeThread rtt = new RealtimeThread(
          null, // Default sceduling Parameters
          new PeriodicParameters(
              null, // Begin running at start()
              new RelativeTime(250, 0), // Period is 1/4 sec
              new RelativeTime(25, 0), // Cost is 1/40 sec
              new RelativeTime(200, 0), // Deadline is 1/5 sec
              null, // No overrun handler
              null), // No miss handler
          null, // Default memory parameters
          null, // Default memory area
          null, // Default processing group
          new Runnable (){ // Logic
            public void run() {
              System.out.println("Running least laxity"); 
            }
          }
        ); 
      rtt.setScheduler(scheduler); 
      rtt.start(); 
      try{
        rtt.join(); 
      }catch(Exception e){}
    }
  }
}
