import javax.realtime.*; 
/**
 * Demonstrate nested scopes
 */
public class Nest1 extends RealtimeThread
{
  String [] args; 
  int [] intArgs; 
  LTMemory mem; 
  LTMemory mem2; 
  
  public Nest1(String [] args)
  {
    this.args = args; 
    intArgs = new int[args.length]; 
  }
  
  class Action implements Runnable
  {
    int i; 
    public void run() {
      // ... compute some
      // Now nest deeper
      mem2.enter(new Runnable() {
        final int j = i; 
        public void run() {
          Integer n = Integer.valueOf(args[j]); 
          intArgs[j] = n.intValue(); 
        }
      }
      ); 
    }
  }
  
  public void run()
  {
    mem = new LTMemory(8*1024, 8*1024); 
    mem2 = new LTMemory(8*1024, 8*1024); 
    Action action = new Action(); 
    
    for(int i=0;i<this.args.length;++i){
      action.i = i; 
      mem.enter(action); 
      System.out.println(intArgs[i]); 
    }
  }
  
  static public void main(String [] args)
  {
    RealtimeThread rt = new Nest1(args); 
    rt.start(); 
    try{
      rt.join(); 
    }catch(Exception e){}; 
  }
}
