import javax.realtime.*; 
/**
 * Demonstrate illegal nested scopes.  
 * Generates a scoped cycle exception
 * This class prevents the scoped cycle exception from
 * causing a boundary exception by catching the exception before
 * it tries to propagate up the stack to a scope where it cannot
 * be referenced.
 */
public class Nest3 extends RealtimeThread
{
  String [] args; 
  int [] intArgs; 
  LTMemory mem; 
  
  public Nest3(String [] args)
  {
    this.args = args; 
    intArgs = new int[args.length]; 
  }
  
  public void run()
  {
    mem = new LTMemory(8*1024, 8*1024); 
    
    for(int i=0;i<this.args.length;++i){
      final int j = i; 
      mem.enter(new Runnable() {
        public void run() {
          // ... compute some
          try{
            mem.enter(new Runnable() {
              // This is illegal
              // The mem memory area is already active
              public void run() {
                Integer n = Integer.valueOf(args[j]); 
                intArgs[j] = n.intValue(); 
              }
            }
            ); 
          }catch(Throwable e){
            e.printStackTrace(); 
            System.exit(0); 
          }
        }
      }
      ); 
      System.out.println(intArgs[i]); 
    }
  }
  
  static public void main(String [] args)
  {
    RealtimeThread rt = new Nest3(args); 
    rt.start(); 
    try{
      rt.join(); 
    }catch(Exception e){}; 
  }
}
