import javax.realtime.*; 
/**
 * Demonstrate a wrong way to do a nested scope
 * This class contains a loop that  allocates a new 
 * runnable every time around
 */
public class SimpleNest extends RealtimeThread
{
  String [] args; 
  int [] intArgs; 
  LTMemory mem; 
  LTMemory mem2; 
  
  public SimpleNest(String [] args)
  {
    this.args = args; 
    intArgs = new int[args.length]; 
  }
  
  public void run()
  {
    mem = new LTMemory(8*1024, 8*1024); 
    
    for(int i=0;i<this.args.length;++i){
      final int j = i; 
      // The Runnable allocated in the next
      // line does not come from mem.  One is
      // allocated every time around the loop
      // and there is nothing here to free them.
      mem.enter(new Runnable() {
        public void run() {
          Integer n = Integer.valueOf(args[j]); 
          intArgs[j] = n.intValue(); 
        }
      }
      ); 
      System.out.println(intArgs[i]); 
    }
  }
  
  static public void main(String [] args)
  {
    RealtimeThread rt = new SimpleNest(args); 
    rt.start(); 
    try{
      rt.join(); 
    }catch(Exception e){}; 
  }
}
