import javax.realtime.*; 
/**
 * Demonstrate a good way to do a nested scope.
 * The runnable object to enter is created before the loop 
 * starts running. 
 */
public class SimpleNest2 extends RealtimeThread
{
  String [] args; 
  int [] intArgs; 
  LTMemory mem; 
  LTMemory mem2; 
  
  public SimpleNest2(String [] args)
  {
    this.args = args; 
    intArgs = new int[args.length]; 
  }
  
  public void run()
  {
    class Action implements Runnable
    {
      int j; 
      public void run() {
        Integer n = Integer.valueOf(args[j]); 
        intArgs[j] = n.intValue(); 
      }
    }
    mem = new LTMemory(8*1024, 8*1024); 
    Action action = new Action(); 
    
    for(int i=0;i<this.args.length;++i){
      action.j = i; 
      mem.enter(action); 
      System.out.println(intArgs[i]); 
    }
  }
  
  static public void main(String [] args)
  {
    RealtimeThread rt = new SimpleNest2(args); 
    rt.start(); 
    try{
      rt.join(); 
    }catch(Exception e){}; 
  }
}
