/** Demonstrate simple use of the SizeEstimator class.
*/
import javax.realtime.*;

public class UseSizeEstimator {

  public static void main(String [] args){
    SizeEstimator sizeEst = new SizeEstimator();

    //  Reserve space for four realtime thread objects
    sizeEst.reserve(RealtimeThread.class, 4);
    //  and space for an Integer
    sizeEst.reserve(Integer.class, 1);
    //  and a RawMemoryAccess object
    sizeEst.reserve(RawMemoryAccess.class, 1);
    LTMemory mem = new LTMemory(sizeEst, sizeEst);
    System.out.println("Memory in scope " + mem.memoryRemaining());
    //  Add another rt thread
    sizeEst.reserve(RealtimeThread.class, 1);
    mem = new LTMemory(sizeEst, sizeEst);
    //  And see how much more memory it wants
    System.out.println("Memory in scope " + mem.memoryRemaining());
  }
}
